#!/bin/sh
# This script is used for feature detection and setting up other
# configurations that are required to build libast.
#
set -e
set -x
bin_dir="$MESON_SOURCE_ROOT/bin"
comp_dir="$MESON_SOURCE_ROOT/src/lib/libast/comp"
PATH=$bin_dir:$PATH

cd "$MESON_SOURCE_ROOT/src/lib/libast/features"
test -d FEATURE || mkdir FEATURE
./siglist.sh > FEATURE/siglist

"$comp_dir/conf.sh" -v "$comp_dir/conf.tab" cc -std=gnu99 -I../include -D_BLD_DLL -D_BLD_ast

for name in sfinit signal; do
    echo "/* This file is autogenerated by libast_prereq.sh script */" > FEATURE/$name
    echo "#ifndef _def_${name}_features" >> FEATURE/$name
    echo "#define _def_${name}_features    1" >> FEATURE/$name
    cc -D_BLD_DLL -D_BLD_ast -I$MESON_BUILD_ROOT -I. -I.. -Icomp -I../comp -Iinclude -I../include \
        -std=gnu99 -Istd -I../std -I../features -o $name $name.c
    ./$name >> FEATURE/$name
    echo "#endif" >> FEATURE/$name
    rm -f $name
done

cd "$MESON_SOURCE_ROOT/src/lib/libast/port"
cc -o "$bin_dir/lcgen" -std=gnu99 -I$MESON_BUILD_ROOT lcgen.c
"$bin_dir/lcgen" ../include/lc.h lctab.c < lc.tab
